#!/usr/bin/perl -w
#
# $Id: AboutDialog.pm,v 1.13 2003/07/23 06:25:50 solovam Exp $
#
# This file is a part of gkismet
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

#
# AboutDialog class
#
package AboutDialog;

use Gnome;
use Misc;
use strict;

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;

	my $gKismetApplication = shift;
	$self->{'gKismetApplication'} = $gKismetApplication;
	
	my $about = new Gnome::About('gkismet', $version,
		'(C) 2003 Anton Solovyev (anton@solovyev.com)', 'Anton Solovyev', 'gkismet - a GtkPerl based Kismet client');
	$about->signal_connect('destroy', sub{$self->destroyHandler()});
	$about->set_parent($gKismetApplication->getWidget());
	$self->{'about'} = $about;
	$about->show();

	return $self;
}

#
# Get widget
#
sub getWidget
{
	my $self = shift;
	return $self->{'about'};
}

#
# Destroy signal handler
#
sub destroyHandler
{
	my $self = shift;
	$self->{'gKismetApplication'}->dialogClose('AboutDialog');
	return($false);
}

1;
