#!/usr/bin/perl -w
#
# $Id: BssConnObserver.pm,v 1.5 2003/07/09 22:48:42 solovam Exp $
#
# This file is a part of gkismet
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

#
# BssConnObserver class
#
package BssConnObserver;

use Misc;
use strict;

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;
	$self->{'gKismetApplication'} = shift;
	$self->{'connection'} = shift;
	$self->{'bssid'} = shift;
	return $self;
}

#
# Close window
#
sub close
{
	my $self = shift;
	$self->{'connection'}->removeObserver($self);
	$self->getWidget()->destroy();
}

#
# Delete signal handler
#
sub deleteHandler
{
	my $self = shift;
	$self->{'gKismetApplication'}->bssObserverClose(ref($self), $self->{'bssid'});
	return($false);
}

#
# Close button clicked
#
sub closeClicked
{
	my $self = shift;
	$self->{'gKismetApplication'}->bssObserverClose(ref($self), $self->{'bssid'});
	return($true);
}

1;
